package com.kernelmaft.zanbur.ui

import android.os.*
import androidx.activity.compose.*
import androidx.compose.foundation.layout.*
import androidx.compose.ui.*
import androidx.compose.ui.unit.*
import androidx.lifecycle.*
import com.kernelmaft.zanbur.common.*
import com.kernelmaft.zanbur.common.ChangeSource.*
import com.kernelmaft.zanbur.network.*



class MainActivity : EdgeToEdgeActivity () {
	override fun onCreate ( savedInstanceState : Bundle ? ) {
		super . onCreate (savedInstanceState)

		val groups = createGroupsComposeState ()

		AppState . subscribeToCurrentScene { group , newScene , source ->
			if ( source == Local ) {
				publishSceneChange ( group , newScene )
			}
		}

		Config . groups . forEach { AppState . addGroup ( it , Remote ) }

		setContent {
			AppFrame {
				Column ( Modifier . width ( 300 . dp ) ) {
					groups . value . forEach { group ->
						SceneSwitcher (group) { newScene ->
							AppState . setCurrentScene ( group , newScene , Local )
						}
					}
				}
			}
		}

		MqttClient . run (lifecycleScope)
	}
}
